from visual import box, color

class block:
    # Initialize the new block object
    def __init__(self, pos, frame, strength, length = 4, height = 1, width = 0):
        self.strength = strength
        self.block = box(size = (length, height, width), frame = frame)
        self.frame = frame
        self.pos = self.block.pos = pos
        self.length = length
        self.height = height
        self.width = width
        self.init_strength = strength
        
        if self.strength == -1:
            self.block.color = (0.5, 0.5, 0.5)
        elif self.strength == 1:
            self.block.color = color.yellow
        elif self.strength == 2:
            self.block.color = color.orange
        elif self.strength == 3:
            self.block.color = color.red
        else:
            self.block.visible = 0
    
    # Update the block's properties after a hit
    def handleHit(self):
        if self.strength > 0:
            self.strength -= 1
            
            if self.strength == 0:
                self.block.visible = 0
                
                if self.init_strength == 3:
                    return 10
                elif self.init_strength == 2:
                    return 5
                else:
                    return 1
            elif self.strength == 1:
                self.block.color = color.yellow
            elif self.strength == 2:
                self.block.color = color.orange
        
        # Return 0 as score (hitting an unbreakable block)
        return 0
    
    # Return the current strength (state) of the block
    def getStrength(self):
        return self.strength
