'''
Tower Tennis
    by Andrew Eshelman, Amanda White, and Sajjan Singh Mehta
    Recitation Assignment #8
    12/06/2007

This file is used to store the patterns that are used to create the blocks obstacles.
There are 10 different subroutines that are randomly called by the pick() funtion/file.
pattern0() is always the first pattern of the game and is never called by pick().
Each subroutine creates a blocks array that keeps track of the type of each blocks
(strength) and it's position.  The array is then added to a frame so that the positions
of the blocks remain constant compared to each other as they move down the screen in the game.
'''

#******************************************************************************
from visual import *
from block import *

#******************************************************************************
def pattern0():
    f = frame(height = 36.5, pos = vector(0, 25))
    blocks = []

    blocks.append(block(vector(0, 0.5), f, 1))

    blocks.append(block(vector(-12, 12.5), f, 1))
    blocks.append(block(vector(-8, 12.5), f, 1))
    blocks.append(block(vector(-4, 12.5), f, 1))
    blocks.append(block(vector(0, 12.5), f, -1))
    blocks.append(block(vector(4, 12.5), f, 1))
    blocks.append(block(vector(8, 12.5), f, 1))
    blocks.append(block(vector(12, 12.5), f, 1))

    blocks.append(block(vector(-12, 24.5), f, 2))
    blocks.append(block(vector(-4, 24.5), f, 2))
    blocks.append(block(vector(4, 24.5), f, 2))
    blocks.append(block(vector(12, 24.5), f, 2))

    blocks.append(block(vector(-8, 36.5), f, 3))
    blocks.append(block(vector(0, 36.5), f, 3))
    blocks.append(block(vector(8, 36.5), f, 3))
    
    '''
    for i in range (len(blocks)):
        blocks[i].height = 1
        blocks[i].length = 4
        blocks[i].width = 0
        blocks[i].frame = f
        
        if blocks[i].strength == 1:
            blocks[i].color = color.yellow
            
        elif blocks[i].strength == 2:
            blocks[i].color = color.orange

        elif blocks[i].strength == 3:
            blocks[i].color = color.red
            
        else:
            blocks[i].color = (0.5, 0.5, 0.5)
    '''

    return f, blocks
    
    
#******************************************************************************
def pattern1():
    f = frame(height = 33.5, pos = vector(0, 25))
    blocks = []
    
    blocks.append(block(vector(0, 0.5), f, 1))
    blocks.append(block(vector(0, 2.5), f, 1))
    blocks.append(block(vector(4, 1.5), f, 1))
    blocks.append(block(vector(4, 3.5), f, 1))
    blocks.append(block(vector(8, 0.5), f, 1))
    blocks.append(block(vector(8, 2.5), f, 1))
    blocks.append(block(vector(12, 1.5), f, 1))
    blocks.append(block(vector(12, 3.5), f, 1))
    blocks.append(block(vector(-4, 1.5), f, 1))
    blocks.append(block(vector(-4, 3.5), f, 1))
    blocks.append(block(vector(-8, 0.5), f, 1))
    blocks.append(block(vector(-8, 2.5), f, 1))
    blocks.append(block(vector(-12, 1.5), f, 1))
    blocks.append(block(vector(-12, 3.5), f, 1))

    for i in range(len(blocks)):
	blocks.append(block(vector(blocks[i].pos.x,blocks[i].pos.y + 10), f, 1))

    for i in range(len(blocks)):
	blocks.append(block(vector(blocks[i].pos.x,blocks[i].pos.y + 20), f, 1))
    
    '''
    for i in range (len(blocks)):
        blocks[i].height = 1
        blocks[i].length = 4
        blocks[i].width = 0
        blocks[i].frame = f
        blocks[i].color = color.yellow
        blocks[i].f, 1
    '''

    return f, blocks


#******************************************************************************
def pattern2():
    f = frame(height = 19.5, pos = vector(0, 25))
    blocks = []
    
    blocks.append(block(vector(0, 0.5), f, -1))
    blocks.append(block(vector(4, 0.5), f, 1))
    blocks.append(block(vector(8, 0.5), f, 1))
    blocks.append(block(vector(12, 0.5), f, 1))
    blocks.append(block(vector(0, 2.5), f, -1))
    blocks.append(block(vector(4, 2.5), f, 1))
    blocks.append(block(vector(8, 2.5), f, 1))
    blocks.append(block(vector(12, 2.5), f, 1))
    blocks.append(block(vector(0, 4.5), f, -1))
    blocks.append(block(vector(4, 4.5), f, 1))
    blocks.append(block(vector(8, 4.5), f, 1))
    blocks.append(block(vector(12, 4.5), f, 1))
    blocks.append(block(vector(0, 6.5), f, -1))
    blocks.append(block(vector(4, 6.5), f, 1))
    blocks.append(block(vector(8, 6.5), f, 1))
    blocks.append(block(vector(12, 6.5), f, 1))
    blocks.append(block(vector(0, 1.5), f, -1))
    blocks.append(block(vector(-4, 1.5), f, 1))
    blocks.append(block(vector(-8, 1.5), f, 1))
    blocks.append(block(vector(-12, 1.5), f, 1))
    blocks.append(block(vector(0, 3.5), f, -1))
    blocks.append(block(vector(-4, 3.5), f, 1))
    blocks.append(block(vector(-8, 3.5), f, 1))
    blocks.append(block(vector(-12, 3.5), f, 1))
    blocks.append(block(vector(0, 5.5), f, -1))
    blocks.append(block(vector(-4, 5.5), f, 1))
    blocks.append(block(vector(-8, 5.5), f, 1))
    blocks.append(block(vector(-12, 5.5), f, 1))
    blocks.append(block(vector(0, 7.5), f, -1))
    blocks.append(block(vector(-4, 7.5), f, 1))
    blocks.append(block(vector(-8, 7.5), f, 1))
    blocks.append(block(vector(-12, 7.5), f, 1))

    #Part 2
    blocks.append(block(vector(0, 12.5), f, -1))
    blocks.append(block(vector(0, 13.5), f, -1))
    blocks.append(block(vector(0, 14.5), f, -1))
    blocks.append(block(vector(0, 15.5), f, -1))
    blocks.append(block(vector(0, 16.5), f, -1))
    blocks.append(block(vector(0, 17.5), f, -1))
    blocks.append(block(vector(0, 18.5), f, -1))
    blocks.append(block(vector(0, 19.5), f, -1))

    blocks.append(block(vector(4, 12.5), f, 1))
    blocks.append(block(vector(8, 12.5), f, 1))
    blocks.append(block(vector(12, 12.5), f, 1))
    blocks.append(block(vector(4, 14.5), f, 1))
    blocks.append(block(vector(8, 14.5), f, 1))
    blocks.append(block(vector(12, 14.5), f, 1))
    blocks.append(block(vector(4, 16.5), f, 1))
    blocks.append(block(vector(8, 16.5), f, 1))
    blocks.append(block(vector(12, 16.5), f, 1))
    blocks.append(block(vector(4, 18.5), f, 1))
    blocks.append(block(vector(8, 18.5), f, 1))
    blocks.append(block(vector(12, 18.5), f, 1))

    blocks.append(block(vector(-4, 18.5), f, 3))
    blocks.append(block(vector(-8, 18.5), f, 3))
    blocks.append(block(vector(-12, 18.5), f, 3))
    blocks.append(block(vector(-4, 19.5), f, 3))
    blocks.append(block(vector(-8, 19.5), f, 3))
    blocks.append(block(vector(-12, 19.5), f, 3))
    
    '''
    for i in range (len(blocks)):
        blocks[i].height = 1
        blocks[i].length = 4
        blocks[i].width = 0
        blocks[i].frame = f
        
        if blocks[i].strength == 1:
            blocks[i].color = color.yellow
            
        elif blocks[i].strength == 2:
            blocks[i].color = color.orange

        elif blocks[i].strength == 3:
            blocks[i].color = color.red
            
        else:
            blocks[i].color = (0.5, 0.5, 0.5)
    '''

    return f, blocks



#******************************************************************************
def pattern3():
    f, blocks = pattern2()

    for i in (f.objects):
        i.pos.x = -i.pos.x

    for i in blocks:
        i.pos.x = -i.pos.x

    return f, blocks



#******************************************************************************

def pattern4():
    f = frame(height = 14.5, pos = vector(0, 25))
    blocks = []

    blocks.append(block(vector(-12, 0.5), f, -1))
    blocks.append(block(vector(-12, 1.5), f, -1))
    blocks.append(block(vector(-12, 2.5), f, -1))
    blocks.append(block(vector(-12, 3.5), f, -1))

    blocks.append(block(vector(-8, 3.5), f, -1))
    blocks.append(block(vector(-8, 4.5), f, -1))
    blocks.append(block(vector(-8, 5.5), f, -1))
    blocks.append(block(vector(-8, 6.5), f, -1))

    blocks.append(block(vector(-4, 6.5), f, -1))
    blocks.append(block(vector(-4, 7.5), f, -1))
    blocks.append(block(vector(-4, 8.5), f, -1))
    blocks.append(block(vector(-4, 9.5), f, -1))

    blocks.append(block(vector(0, 9.5), f, -1))
    blocks.append(block(vector(0, 10.5), f, -1))
    blocks.append(block(vector(0, 11.5), f, -1))
    blocks.append(block(vector(0, 12.5), f, -1))

    blocks.append(block(vector(4, 12.5), f, -1))
    blocks.append(block(vector(4, 13.5), f, -1))
    blocks.append(block(vector(4, 14.5), f, -1))

    blocks.append(block(vector(-8, 2.5), f, 1))
    blocks.append(block(vector(-4, 2.5), f, 1))
    blocks.append(block(vector(0, 2.5), f, 1))
    blocks.append(block(vector(4, 2.5), f, 1))
    blocks.append(block(vector(8, 2.5), f, 1))
    blocks.append(block(vector(12, 2.5), f, 1))

    blocks.append(block(vector(-4, 5.5), f, 1))
    blocks.append(block(vector(0, 5.5), f, 1))
    blocks.append(block(vector(4, 5.5), f, 1))
    blocks.append(block(vector(8, 5.5), f, 1))
    blocks.append(block(vector(12, 5.5), f, 1))

    blocks.append(block(vector(0, 8.5), f, 1))
    blocks.append(block(vector(4, 8.5), f, 1))
    blocks.append(block(vector(8, 8.5), f, 1))
    blocks.append(block(vector(12, 8.5), f, 1))

    blocks.append(block(vector(4, 11.5), f, 1))
    blocks.append(block(vector(8, 11.5), f, 1))
    blocks.append(block(vector(12, 11.5), f, 1))

    blocks.append(block(vector(8, 14.5), f, 1))
    blocks.append(block(vector(12, 14.5), f, 1))
    
    '''
    for i in range (len(blocks)):
        blocks[i].height = 1
        blocks[i].length = 4
        blocks[i].width = 0
        blocks[i].frame = f
        
        if blocks[i].strength == 1:
            blocks[i].color = color.yellow
            
        elif blocks[i].strength == 2:
            blocks[i].color = color.orange

        elif blocks[i].strength == 3:
            blocks[i].color = color.red
            
        else:
            blocks[i].color = (0.5, 0.5, 0.5)
    '''

    return f, blocks
    

#******************************************************************************
def pattern5():
    f, blocks = pattern4()

    for i in (f.objects):
        i.pos.x = -i.pos.x

    for i in blocks:
        i.pos.x = -i.pos.x

    return f, blocks

#******************************************************************************
def pattern6():
    f = frame(height = 14.5, pos = vector(0, 25))
    blocks = []

    blocks.append(block(vector(-12, 0.5), f, 3))
    blocks.append(block(vector(-8, 0.5), f, 3))
    blocks.append(block(vector(-4, 0.5), f, 3))
    blocks.append(block(vector(0, 0.5), f, 3))
    blocks.append(block(vector(4, 0.5), f, 3))
    blocks.append(block(vector(8, 0.5), f, 3))
    blocks.append(block(vector(12, 0.5), f, 3))

    blocks.append(block(vector(-10, 1.5), f, 3))
    blocks.append(block(vector(-6, 1.5), f, 3))
    blocks.append(block(vector(-2, 1.5), f, 3))
    blocks.append(block(vector(2, 1.5), f, 3))
    blocks.append(block(vector(6, 1.5), f, 3))
    blocks.append(block(vector(10, 1.5), f, 3))

    blocks.append(block(vector(-8, 2.5), f, 2))
    blocks.append(block(vector(-4, 2.5), f, 2))
    blocks.append(block(vector(0, 2.5), f, 2))
    blocks.append(block(vector(4, 2.5), f, 2))
    blocks.append(block(vector(8, 2.5), f, 2))

    blocks.append(block(vector(-6, 3.5), f, 2))
    blocks.append(block(vector(-2, 3.5), f, 2))
    blocks.append(block(vector(2, 3.5), f, 2))
    blocks.append(block(vector(6, 3.5), f, 2))

    blocks.append(block(vector(-4, 4.5), f, 2))
    blocks.append(block(vector(0, 4.5), f, 2))
    blocks.append(block(vector(4, 4.5), f, 2))

    blocks.append(block(vector(-2, 5.5), f, 1))
    blocks.append(block(vector(2, 5.5), f, 1))

    blocks.append(block(vector(0, 6.5), f, 1))
    blocks.append(block(vector(0, 7.5), f, -1))
    blocks.append(block(vector(0, 8.5), f, 1))

    blocks.append(block(vector(-2, 9.5), f, 1))
    blocks.append(block(vector(2, 9.5), f, 1))

    blocks.append(block(vector(-4, 10.5), f, 2))
    blocks.append(block(vector(0, 10.5), f, 2))
    blocks.append(block(vector(4, 10.5), f, 2))

    blocks.append(block(vector(-6, 11.5), f, 2))
    blocks.append(block(vector(-2, 11.5), f, 2))
    blocks.append(block(vector(2, 11.5), f, 2))
    blocks.append(block(vector(6, 11.5), f, 2))

    blocks.append(block(vector(-8, 12.5), f, 2))
    blocks.append(block(vector(-4, 12.5), f, 2))
    blocks.append(block(vector(0, 12.5), f, 2))
    blocks.append(block(vector(4, 12.5), f, 2))
    blocks.append(block(vector(8, 12.5), f, 2))

    blocks.append(block(vector(-10, 13.5), f, 3))
    blocks.append(block(vector(-6, 13.5), f, 3))
    blocks.append(block(vector(-2, 13.5), f, 3))
    blocks.append(block(vector(2, 13.5), f, 3))
    blocks.append(block(vector(6, 13.5), f, 3))
    blocks.append(block(vector(10, 13.5), f, 3))

    blocks.append(block(vector(-12, 14.5), f, 3))
    blocks.append(block(vector(-8, 14.5), f, 3))
    blocks.append(block(vector(-4, 14.5), f, 3))
    blocks.append(block(vector(0, 14.5), f, 3))
    blocks.append(block(vector(4, 14.5), f, 3))
    blocks.append(block(vector(8, 14.5), f, 3))
    blocks.append(block(vector(12, 14.5), f, 3))
    
    '''
    for i in range (len(blocks)):
        blocks[i].height = 1
        blocks[i].length = 4
        blocks[i].width = 0
        blocks[i].frame = f
        
        if blocks[i].strength == 1:
            blocks[i].color = color.yellow
            
        elif blocks[i].strength == 2:
            blocks[i].color = color.orange

        elif blocks[i].strength == 3:
            blocks[i].color = color.red
            
        else:
            blocks[i].color = (0.5, 0.5, 0.5)
    '''
            
    return f, blocks


#******************************************************************************
def pattern7():
    f = frame(height = 6.5, pos = vector(0, 25))
    blocks = []

    blocks.append(block(vector(-12, 0.5), f, 3))
    blocks.append(block(vector(-8, 0.5), f, 3))
    blocks.append(block(vector(-4, 0.5), f, 3))
    blocks.append(block(vector(0, 0.5), f, 3))
    blocks.append(block(vector(4, 0.5), f, 3))
    blocks.append(block(vector(8, 0.5), f, 3))
    blocks.append(block(vector(12, 0.5), f, 3))

    blocks.append(block(vector(-12, 1.5), f, 2))
    blocks.append(block(vector(-8, 1.5), f, 2))
    blocks.append(block(vector(-4, 1.5), f, 2))
    blocks.append(block(vector(0, 1.5), f, 2))
    blocks.append(block(vector(4, 1.5), f, 2))
    blocks.append(block(vector(8, 1.5), f, 2))

    blocks.append(block(vector(-12, 2.5), f, 1))
    blocks.append(block(vector(-8, 2.5), f, 1))
    blocks.append(block(vector(-4, 2.5), f, 1))
    blocks.append(block(vector(0, 2.5), f, 1))
    blocks.append(block(vector(4, 2.5), f, 1))

    blocks.append(block(vector(-12, 3.5), f, 1))
    blocks.append(block(vector(-8, 3.5), f, 1))
    blocks.append(block(vector(-4, 3.5), f, 1))
    blocks.append(block(vector(0, 3.5), f, 1))

    blocks.append(block(vector(-12, 4.5), f, 1))
    blocks.append(block(vector(-8, 4.5), f, 1))
    blocks.append(block(vector(-4, 4.5), f, 1))

    blocks.append(block(vector(-12, 5.5), f, 1))
    blocks.append(block(vector(-8, 5.5), f, 1))

    blocks.append(block(vector(-12, 6.5), f, 1))
    
    '''
    for i in range (len(blocks)):
        blocks[i].height = 1
        blocks[i].length = 4
        blocks[i].width = 0
        blocks[i].frame = f
        
        if blocks[i].strength == 1:
            blocks[i].color = color.yellow
            
        elif blocks[i].strength == 2:
            blocks[i].color = color.orange

        elif blocks[i].strength == 3:
            blocks[i].color = color.red
            
        else:
            blocks[i].color = (0.5, 0.5, 0.5)
    '''
            
    return f, blocks

#******************************************************************************
def pattern8():
    f, blocks = pattern7()

    for i in (f.objects):
        i.pos.x = -i.pos.x

    for i in blocks:
        i.pos.x = -i.pos.x

    return f, blocks

#******************************************************************************
def pattern9():
    f = frame(height = 17.5, pos = vector(0, 25))
    blocks = []

    blocks.append(block(vector(3, 0.5), f, 1))
    blocks.append(block(vector(7, 0.5), f, 1))
    blocks.append(block(vector(11, 0.5), f, 1))
    blocks.append(block(vector(3, 1.5), f, 1))
    blocks.append(block(vector(7, 1.5), f, 3))
    blocks.append(block(vector(11, 1.5), f, 1))
    blocks.append(block(vector(3, 2.5), f, 1))
    blocks.append(block(vector(7, 2.5), f, 1))
    blocks.append(block(vector(11, 2.5), f, 1))

    blocks.append(block(vector(-3, 3.5), f, 1))
    blocks.append(block(vector(-7, 3.5), f, 1))
    blocks.append(block(vector(-11, 3.5), f, 1))
    blocks.append(block(vector(-3, 4.5), f, 1))
    blocks.append(block(vector(-7, 4.5), f, 3))
    blocks.append(block(vector(-11, 4.5), f, 1))
    blocks.append(block(vector(-3, 5.5), f, 1))
    blocks.append(block(vector(-7, 5.5), f, 1))
    blocks.append(block(vector(-11, 5.5), f, 1))

    blocks.append(block(vector(3, 6.5), f, 1))
    blocks.append(block(vector(7, 6.5), f, 1))
    blocks.append(block(vector(11, 6.5), f, 1))
    blocks.append(block(vector(3, 7.5), f, 1))
    blocks.append(block(vector(7, 7.5), f, 3))
    blocks.append(block(vector(11, 7.5), f, 1))
    blocks.append(block(vector(3, 8.5), f, 1))
    blocks.append(block(vector(7, 8.5), f, 1))
    blocks.append(block(vector(11, 8.5), f, 1))

    blocks.append(block(vector(-3, 9.5), f, 1))
    blocks.append(block(vector(-7, 9.5), f, 1))
    blocks.append(block(vector(-11, 9.5), f, 1))
    blocks.append(block(vector(-3, 10.5), f, 1))
    blocks.append(block(vector(-7, 10.5), f, 3))
    blocks.append(block(vector(-11, 10.5), f, 1))
    blocks.append(block(vector(-3, 11.5), f, 1))
    blocks.append(block(vector(-7, 11.5), f, 1))
    blocks.append(block(vector(-11, 11.5), f, 1))

    blocks.append(block(vector(3, 12.5), f, 1))
    blocks.append(block(vector(7, 12.5), f, 1))
    blocks.append(block(vector(11, 12.5), f, 1))
    blocks.append(block(vector(3, 13.5), f, 1))
    blocks.append(block(vector(7, 13.5), f, 3))
    blocks.append(block(vector(11, 13.5), f, 1))
    blocks.append(block(vector(3, 14.5), f, 1))
    blocks.append(block(vector(7, 14.5), f, 1))
    blocks.append(block(vector(11, 14.5), f, 1))

    blocks.append(block(vector(-3, 15.5), f, 1))
    blocks.append(block(vector(-7, 15.5), f, 1))
    blocks.append(block(vector(-11, 15.5), f, 1))
    blocks.append(block(vector(-3, 16.5), f, 1))
    blocks.append(block(vector(-7, 16.5), f, 3))
    blocks.append(block(vector(-11, 16.5), f, 1))
    blocks.append(block(vector(-3, 17.5), f, 1))
    blocks.append(block(vector(-7, 17.5), f, 1))
    blocks.append(block(vector(-11, 17.5), f, 1))
    
    '''
    for i in range (len(blocks)):
        blocks[i].height = 1
        blocks[i].length = 4
        blocks[i].width = 0
        blocks[i].frame = f
        
        if blocks[i].strength == 1:
            blocks[i].color = color.yellow
            
        elif blocks[i].strength == 2:
            blocks[i].color = color.orange

        elif blocks[i].strength == 3:
            blocks[i].color = color.red
            
        else:
            blocks[i].color = (0.5, 0.5, 0.5)
    '''
            
    return f, blocks

#******************************************************************************
def pattern10():
    f, blocks = pattern9()

    for i in (f.objects):
        i.pos.x = -i.pos.x

    for i in blocks:
        i.pos.x = -i.pos.x

    return f, blocks

#******************************************************************************
    
