'''
Tower Tennis
    by Andrew Eshelman, Amanda White, and Sajjan Singh Mehta
    Recitation Assignment #8
    12/06/2007

This file is used to store the special patterns that are used to create the block obstacles.
The file is similar to the pattern file except these patterns are only used every fifth pattern.
Each subroutine creates a block array that keeps track of the type of each block(strength) and it's position.
The array is then added to a frame so that the positions of the blocks remain constant compared to each other as
they move down the screen in the game.
'''
#******************************************************************************
from visual import *
from block import *

#******************************************************************************

nextframe = []
nextblocks = []

#******************************************************************************
def special1(): 
    f = frame(height = 18, pos = vector(0, 25))
    blocks = []
    
    label(pos = (0, 10, 0), text = 'Professor Goldberg\n    and Travis', height = 20, frame = f,
          linecolor = color.black, color = color.red)

    #First half of heart, second in loop
    blocks.append(block(vector(1, 1), f, 3, 2))
    blocks.append(block(vector(2, 2), f, 3, 2))
    blocks.append(block(vector(3, 3), f, 3, 2))
    blocks.append(block(vector(4, 4), f, 3, 2))
    blocks.append(block(vector(5, 5), f, 3, 2))
    blocks.append(block(vector(6, 6), f, 3, 2))
    blocks.append(block(vector(7, 7), f, 3, 2))
    blocks.append(block(vector(8, 8), f, 3, 2))
    blocks.append(block(vector(9, 9), f, 3, 2))
    blocks.append(block(vector(10, 10), f, 3, 2))
    blocks.append(block(vector(11, 11), f, 3, 2))
    blocks.append(block(vector(11, 12), f, 3, 2))
    blocks.append(block(vector(11, 13), f, 3, 2))
    blocks.append(block(vector(11, 14), f, 3, 2))
    blocks.append(block(vector(10, 15), f, 3, 2))
    blocks.append(block(vector(9, 16), f, 3, 2))
    blocks.append(block(vector(8, 17), f, 3, 2))
    blocks.append(block(vector(7, 18), f, 3, 2))
    blocks.append(block(vector(5, 18), f, 3, 2))
    blocks.append(block(vector(3, 18), f, 3, 2))
    blocks.append(block(vector(2, 17), f, 3, 2))
    blocks.append(block(vector(1, 16), f, 3, 2))
    blocks.append(block(vector(0, 0), f, 3, 2))

    for i in range(len(blocks)-1):
        blocks.append(block(vector(-blocks[i].pos.x, blocks[i].pos.y), f, 3, 2))
    
    special1_2()
    special1_3()
    
    return f, blocks

def special1_2():
    f = frame(height = 16, pos = vector(0, 25))
    blocks = []
    
    #Words
    #Y
    blocks.append(block(vector(-8, 0), f, 3, 2))
    blocks.append(block(vector(-8, 1), f, 3, 2))
    blocks.append(block(vector(-8, 2), f, 3, 2))
    blocks.append(block(vector(-8, 3), f, 3, 2))
    
    blocks.append(block(vector(-7, 4), f, 3, 2))
    blocks.append(block(vector(-9, 4), f, 3, 2))
    blocks.append(block(vector(-6, 5), f, 3, 2))
    blocks.append(block(vector(-10, 5), f, 3, 2))
    blocks.append(block(vector(-5, 6), f, 3, 2))
    blocks.append(block(vector(-11, 6), f, 3, 2))

    #O
    blocks.append(block(vector(-1, 0), f, 3, 2))
    blocks.append(block(vector(-1, 1), f, 3, 2))
    blocks.append(block(vector(-1, 2), f, 3, 2))
    blocks.append(block(vector(-1, 3), f, 3, 2))
    blocks.append(block(vector(-1, 4), f, 3, 2))
    blocks.append(block(vector(-1, 5), f, 3, 2))
    blocks.append(block(vector(-1, 6), f, 3, 2))
    
    blocks.append(block(vector(3, 0), f, 3, 2))
    blocks.append(block(vector(3, 1), f, 3, 2))
    blocks.append(block(vector(3, 2), f, 3, 2))
    blocks.append(block(vector(3, 3), f, 3, 2))
    blocks.append(block(vector(3, 4), f, 3, 2))
    blocks.append(block(vector(3, 5), f, 3, 2))
    blocks.append(block(vector(3, 6), f, 3, 2))
    
    blocks.append(block(vector(1, 0), f, 3, 2))
    blocks.append(block(vector(1, 1), f, 3, 2))
    blocks.append(block(vector(1, 5), f, 3, 2))
    blocks.append(block(vector(1, 6), f, 3, 2))

    #U
    blocks.append(block(vector(7, 0), f, 3, 2))
    blocks.append(block(vector(7, 1), f, 3, 2))
    blocks.append(block(vector(7, 2), f, 3, 2))
    blocks.append(block(vector(7, 3), f, 3, 2))
    blocks.append(block(vector(7, 4), f, 3, 2))
    blocks.append(block(vector(7, 5), f, 3, 2))
    blocks.append(block(vector(7, 6), f, 3, 2))

    blocks.append(block(vector(11, 0), f, 3, 2))
    blocks.append(block(vector(11, 1), f, 3, 2))
    blocks.append(block(vector(11, 2), f, 3, 2))
    blocks.append(block(vector(11, 3), f, 3, 2))
    blocks.append(block(vector(11, 4), f, 3, 2))
    blocks.append(block(vector(11, 5), f, 3, 2))
    blocks.append(block(vector(11, 6), f, 3, 2))

    blocks.append(block(vector(9, 0), f, 3, 2))
    blocks.append(block(vector(9, 1), f, 3, 2))

    #G
    blocks.append(block(vector(-14, 10), f, 3, 2))
    blocks.append(block(vector(-14, 11), f, 3, 2))
    blocks.append(block(vector(-14, 12), f, 3, 2))
    blocks.append(block(vector(-14, 13), f, 3, 2))
    blocks.append(block(vector(-14, 14), f, 3, 2))
    blocks.append(block(vector(-14, 15), f, 3, 2))
    blocks.append(block(vector(-14, 16), f, 3, 2))

    blocks.append(block(vector(-12, 10), f, 3, 2))
    blocks.append(block(vector(-12, 11), f, 3, 2))
    blocks.append(block(vector(-12, 15), f, 3, 2))
    blocks.append(block(vector(-12, 16), f, 3, 2))

    blocks.append(block(vector(-10, 10), f, 3, 2))
    blocks.append(block(vector(-10, 11), f, 3, 2))
    blocks.append(block(vector(-10, 12), f, 3, 2))
    blocks.append(block(vector(-10, 15), f, 3, 2))
    blocks.append(block(vector(-10, 16), f, 3, 2))

    blocks.append(block(vector(-11, 13), f, 3, 2))
    blocks.append(block(vector(-9, 13), f, 3, 2))

    #U
    blocks.append(block(vector(-6, 10), f, 3, 2))
    blocks.append(block(vector(-6, 11), f, 3, 2))
    blocks.append(block(vector(-6, 12), f, 3, 2))
    blocks.append(block(vector(-6, 13), f, 3, 2))
    blocks.append(block(vector(-6, 14), f, 3, 2))
    blocks.append(block(vector(-6, 15), f, 3, 2))
    blocks.append(block(vector(-6, 16), f, 3, 2))

    blocks.append(block(vector(-2, 10), f, 3, 2))
    blocks.append(block(vector(-2, 11), f, 3, 2))
    blocks.append(block(vector(-2, 12), f, 3, 2))
    blocks.append(block(vector(-2, 13), f, 3, 2))
    blocks.append(block(vector(-2, 14), f, 3, 2))
    blocks.append(block(vector(-2, 15), f, 3, 2))
    blocks.append(block(vector(-2, 16), f, 3, 2))

    blocks.append(block(vector(-4, 10), f, 3, 2))
    blocks.append(block(vector(-4, 11), f, 3, 2))

    #Y
    blocks.append(block(vector(4, 10), f, 3, 2))
    blocks.append(block(vector(4, 11), f, 3, 2))
    blocks.append(block(vector(4, 12), f, 3, 2))
    blocks.append(block(vector(4, 13), f, 3, 2))
    
    blocks.append(block(vector(3, 14), f, 3, 2))
    blocks.append(block(vector(5, 14), f, 3, 2))
    blocks.append(block(vector(2, 15), f, 3, 2))
    blocks.append(block(vector(6, 15), f, 3, 2))
    blocks.append(block(vector(1, 16), f, 3, 2))
    blocks.append(block(vector(7, 16), f, 3, 2))

    #S
    blocks.append(block(vector(10.5, 10), f, 3, 2))
    blocks.append(block(vector(12.5, 10), f, 3, 2))
    blocks.append(block(vector(9.5, 11), f, 3, 2))
    blocks.append(block(vector(13, 11), f, 3, 2))
    blocks.append(block(vector(12.5, 12), f, 3, 2))

    blocks.append(block(vector(12, 13), f, 3, 2))
    blocks.append(block(vector(11, 14), f, 3, 2))
    blocks.append(block(vector(10, 15), f, 3, 2))
    blocks.append(block(vector(11, 16), f, 3, 2))
    blocks.append(block(vector(13, 16), f, 3, 2))
    blocks.append(block(vector(14, 15), f, 3, 2))
    
    for b in blocks:
        b.block.visible = 0
    
    nextframe.append(f)
    nextblocks.append(blocks)
    
def special1_3():
    f = frame(height = 15, pos = vector(0, 25))
    blocks = []
    
    #Words
    #A
    blocks.append(block(vector(-11, 0), f, 3, 2))
    blocks.append(block(vector(-10.5, 1), f, 3, 2))
    blocks.append(block(vector(-10, 2), f, 3, 2))
    blocks.append(block(vector(-9.5, 3), f, 3, 2))
    blocks.append(block(vector(-9, 4), f, 3, 2))
    blocks.append(block(vector(-8.5, 5), f, 3, 2))
    blocks.append(block(vector(-7.5, 6), f, 3, 2))

    blocks.append(block(vector(-4, 0), f, 3, 2))
    blocks.append(block(vector(-4.5, 1), f, 3, 2))
    blocks.append(block(vector(-5, 2), f, 3, 2))
    blocks.append(block(vector(-5.5, 3), f, 3, 2))
    blocks.append(block(vector(-6, 4), f, 3, 2))
    blocks.append(block(vector(-6.5, 5), f, 3, 2))

    blocks.append(block(vector(-7.5, 3), f, 3, 2))

    #R
    blocks.append(block(vector(-1, 0), f, 3, 2))
    blocks.append(block(vector(-1, 1), f, 3, 2))
    blocks.append(block(vector(-1, 2), f, 3, 2))
    blocks.append(block(vector(-1, 3), f, 3, 2))
    blocks.append(block(vector(-1, 4), f, 3, 2))
    blocks.append(block(vector(-1, 5), f, 3, 2))
    blocks.append(block(vector(-1, 6), f, 3, 2))

    blocks.append(block(vector(3, 3), f, 3, 2))
    blocks.append(block(vector(3, 6), f, 3, 2))
    blocks.append(block(vector(1, 3), f, 3, 2))
    blocks.append(block(vector(1, 6), f, 3, 2))

    blocks.append(block(vector(3.5, 5), f, 3, 2))
    blocks.append(block(vector(3.5, 4), f, 3, 2))
    blocks.append(block(vector(3.5, 2), f, 3, 2))
    blocks.append(block(vector(3.5, 1), f, 3, 2))
    blocks.append(block(vector(3.5, 0), f, 3, 2))

    #E
    blocks.append(block(vector(7, 0), f, 3, 2))
    blocks.append(block(vector(7, 1), f, 3, 2))
    blocks.append(block(vector(7, 2), f, 3, 2))
    blocks.append(block(vector(7, 3), f, 3, 2))
    blocks.append(block(vector(7, 4), f, 3, 2))
    blocks.append(block(vector(7, 5), f, 3, 2))
    blocks.append(block(vector(7, 6), f, 3, 2))

    blocks.append(block(vector(9, 0), f, 3, 2))
    blocks.append(block(vector(11, 0), f, 3, 2))
    blocks.append(block(vector(9, 6), f, 3, 2))
    blocks.append(block(vector(11, 6), f, 3, 2))
    blocks.append(block(vector(9, 3), f, 3, 2))

    #G
    blocks.append(block(vector(-13, 9), f, 3, 2))
    blocks.append(block(vector(-13, 10), f, 3, 2))
    blocks.append(block(vector(-13, 11), f, 3, 2))
    blocks.append(block(vector(-13, 12), f, 3, 2))
    blocks.append(block(vector(-13, 13), f, 3, 2))
    blocks.append(block(vector(-13, 14), f, 3, 2))
    blocks.append(block(vector(-13, 15), f, 3, 2))

    blocks.append(block(vector(-11, 9), f, 3, 2))
    blocks.append(block(vector(-11, 10), f, 3, 2))
    blocks.append(block(vector(-11, 14), f, 3, 2))
    blocks.append(block(vector(-11, 15), f, 3, 2))

    blocks.append(block(vector(-9, 9), f, 3, 2))
    blocks.append(block(vector(-9, 10), f, 3, 2))
    blocks.append(block(vector(-9, 11), f, 3, 2))
    blocks.append(block(vector(-9, 14), f, 3, 2))
    blocks.append(block(vector(-9, 15), f, 3, 2))

    blocks.append(block(vector(-10, 12), f, 3, 2))
    blocks.append(block(vector(-8, 12), f, 3, 2))

    #R
    blocks.append(block(vector(-4, 9), f, 3, 2))
    blocks.append(block(vector(-4, 10), f, 3, 2))
    blocks.append(block(vector(-4, 11), f, 3, 2))
    blocks.append(block(vector(-4, 12), f, 3, 2))
    blocks.append(block(vector(-4, 13), f, 3, 2))
    blocks.append(block(vector(-4, 14), f, 3, 2))
    blocks.append(block(vector(-4, 15), f, 3, 2))

    blocks.append(block(vector(-2, 12), f, 3, 2))
    blocks.append(block(vector(0, 12), f, 3, 2))
    blocks.append(block(vector(0, 15), f, 3, 2))
    blocks.append(block(vector(-2, 15), f, 3, 2))

    blocks.append(block(vector(1, 14), f, 3, 2))
    blocks.append(block(vector(1, 13), f, 3, 2))
    blocks.append(block(vector(1, 11), f, 3, 2))
    blocks.append(block(vector(1, 10), f, 3, 2))
    blocks.append(block(vector(1, 9), f, 3, 2))

    #8!
    blocks.append(block(vector(5, 9), f, 3, 2))
    blocks.append(block(vector(5, 10), f, 3, 2))
    blocks.append(block(vector(5, 11), f, 3, 2))
    blocks.append(block(vector(5, 12), f, 3, 2))
    blocks.append(block(vector(5, 13), f, 3, 2))
    blocks.append(block(vector(5, 14), f, 3, 2))
    blocks.append(block(vector(5, 15), f, 3, 2))

    blocks.append(block(vector(7, 9), f, 3, 2))
    blocks.append(block(vector(7, 10), f, 3, 2))

    blocks.append(block(vector(7, 12), f, 3, 2))

    blocks.append(block(vector(7, 14), f, 3, 2))
    blocks.append(block(vector(7, 15), f, 3, 2))

    blocks.append(block(vector(9, 9), f, 3, 2))
    blocks.append(block(vector(9, 10), f, 3, 2))
    blocks.append(block(vector(9, 11), f, 3, 2))
    blocks.append(block(vector(9, 12), f, 3, 2))
    blocks.append(block(vector(9, 13), f, 3, 2))
    blocks.append(block(vector(9, 14), f, 3, 2))
    blocks.append(block(vector(9, 15), f, 3, 2))

    blocks.append(block(vector(13, 9), f, 3, 2))
    blocks.append(block(vector(13, 10), f, 3, 2))

    blocks.append(block(vector(13, 12), f, 3, 2))
    blocks.append(block(vector(13, 13), f, 3, 2))
    blocks.append(block(vector(13, 14), f, 3, 2))
    blocks.append(block(vector(13, 15), f, 3, 2))
    
    for b in blocks:
        b.block.visible = 0

    nextframe.append(f)
    nextblocks.append(blocks)

#******************************************************************************
def special2():
    f = frame(height = 18, pos = vector(0, 25))
    blocks = []

    blocks.append(block(vector(1, 1), f, 3, 2))
    blocks.append(block(vector(2, 2), f, 3, 2))
    blocks.append(block(vector(3, 3), f, 3, 2))
    blocks.append(block(vector(4, 4), f, 3, 2))
    blocks.append(block(vector(5, 5), f, 3, 2))
    blocks.append(block(vector(6, 6), f, 3, 2))
    blocks.append(block(vector(7, 7), f, 3, 2))
    blocks.append(block(vector(8, 8), f, 3, 2))
    blocks.append(block(vector(9, 9), f, 3, 2))
    blocks.append(block(vector(10, 10), f, 3, 2))
    blocks.append(block(vector(11, 11), f, 3, 2))
    blocks.append(block(vector(11, 12), f, 3, 2))
    blocks.append(block(vector(11, 13), f, 3, 2))
    blocks.append(block(vector(11, 14), f, 3, 2))
    blocks.append(block(vector(10, 15), f, 3, 2))
    blocks.append(block(vector(9, 16), f, 3, 2))
    blocks.append(block(vector(8, 17), f, 3, 2))
    blocks.append(block(vector(7, 18), f, 3, 2))
    blocks.append(block(vector(5, 18), f, 3, 2))
    blocks.append(block(vector(3, 18), f, 3, 2))
    blocks.append(block(vector(2, 17), f, 3, 2))
    blocks.append(block(vector(1, 16), f, 3, 2))
    blocks.append(block(vector(0, 0), f, 3, 2))

    for i in range(22):
        blocks.append(block(vector(-blocks[i].pos.x, blocks[i].pos.y), f, 3, 2))

    for i in range(22):
        blocks.append(block(vector(-blocks[i].pos.x, -blocks[i].pos.y), f, 3, 2))

    for i in range(22):
        blocks.append(block(vector(blocks[i].pos.x, -blocks[i].pos.y), f, 3, 2))
    
    for i in range(len(blocks)):
	    blocks[i].pos.y += 20

    for i in (f.objects):
	    i.pos.y +=20
    
    '''
    for i in range (len(blocks)):
        blocks[i].height = 1
        blocks[i].length = 2
        blocks[i].width = 0
        blocks[i].frame = f
        
        if blocks[i].strength == 1:
            blocks[i].color = color.yellow
            
        elif blocks[i].strength == 2:
            blocks[i].color = color.orange

        elif blocks[i].strength == 3:
            blocks[i].color = color.red
            
        else:
            blocks[i].color = (0.5, 0.5, 0.5)
    '''        
    return f, blocks

#******************************************************************************
def special3():
    f = frame(height = 22, pos = vector(0, 25))
    blocks = []

    # Pi
    blocks.append(block(vector(-11, 1), f, 2, 2))
    blocks.append(block(vector(-11, 2), f, 2, 2))
    blocks.append(block(vector(-11, 3), f, 2, 2))
    blocks.append(block(vector(-11, 4), f, 2, 2))
    blocks.append(block(vector(-11, 5), f, 2, 2))
    blocks.append(block(vector(-11, 6), f, 2, 2))

    blocks.append(block(vector(-6, 1), f, 2, 2))
    blocks.append(block(vector(-6, 2), f, 2, 2))
    blocks.append(block(vector(-6, 3), f, 2, 2))
    blocks.append(block(vector(-6, 4), f, 2, 2))
    blocks.append(block(vector(-6, 5), f, 2, 2))
    blocks.append(block(vector(-6, 6), f, 2, 2))

    blocks.append(block(vector(-13, 7), f, 2, 2))
    blocks.append(block(vector(-11, 7), f, 2, 2))
    blocks.append(block(vector(-9, 7), f, 2, 2))
    blocks.append(block(vector(-7, 7), f, 2, 2))
    blocks.append(block(vector(-5, 7), f, 2, 2))

    blocks.append(block(vector(-13, 8), f, 2, 2))
    blocks.append(block(vector(-11, 8), f, 2, 2))
    blocks.append(block(vector(-9, 8), f, 2, 2))
    blocks.append(block(vector(-7, 8), f, 2, 2))
    blocks.append(block(vector(-5, 8), f, 2, 2))

    # Pi 2
    blocks.append(block(vector(-11, 16), f, 2, 2))
    blocks.append(block(vector(-11, 17), f, 2, 2))
    blocks.append(block(vector(-11, 18), f, 2, 2))
    blocks.append(block(vector(-11, 19), f, 2, 2))
    blocks.append(block(vector(-11, 20), f, 2, 2))

    blocks.append(block(vector(-6, 16), f, 2, 2))
    blocks.append(block(vector(-6, 17), f, 2, 2))
    blocks.append(block(vector(-6, 18), f, 2, 2))
    blocks.append(block(vector(-6, 19), f, 2, 2))
    blocks.append(block(vector(-6, 20), f, 2, 2))

    blocks.append(block(vector(-13, 21), f, 2, 2))
    blocks.append(block(vector(-11, 21), f, 2, 2))
    blocks.append(block(vector(-9, 21), f, 2, 2))
    blocks.append(block(vector(-7, 21), f, 2, 2))
    blocks.append(block(vector(-5, 21), f, 2, 2))

    blocks.append(block(vector(-13, 22), f, 2, 2))
    blocks.append(block(vector(-11, 22), f, 2, 2))
    blocks.append(block(vector(-9, 22), f, 2, 2))
    blocks.append(block(vector(-7, 22), f, 2, 2))
    blocks.append(block(vector(-5, 22), f, 2, 2))

    # Pi 3
    blocks.append(block(vector(7, 13), f, 2, 2))
    blocks.append(block(vector(7, 14), f, 2, 2))
    blocks.append(block(vector(7, 15), f, 2, 2))
    blocks.append(block(vector(7, 16), f, 2, 2))
    blocks.append(block(vector(7, 17), f, 2, 2))

    blocks.append(block(vector(12, 13), f, 2, 2))
    blocks.append(block(vector(12, 14), f, 2, 2))
    blocks.append(block(vector(12, 15), f, 2, 2))
    blocks.append(block(vector(12, 16), f, 2, 2))
    blocks.append(block(vector(12, 17), f, 2, 2))

    blocks.append(block(vector(13, 18), f, 2, 2))
    blocks.append(block(vector(11, 18), f, 2, 2))
    blocks.append(block(vector(9, 18), f, 2, 2))
    blocks.append(block(vector(7, 18), f, 2, 2))
    blocks.append(block(vector(5, 18), f, 2, 2))

    blocks.append(block(vector(13, 19), f, 2, 2))
    blocks.append(block(vector(11, 19), f, 2, 2))
    blocks.append(block(vector(9, 19), f, 2, 2))
    blocks.append(block(vector(7, 19), f, 2, 2))
    blocks.append(block(vector(5, 19), f, 2, 2))

    #3.14
    blocks.append(block(vector(-11, 10), f, 3, 2))
    blocks.append(block(vector(-11, 12), f, 3, 2))
    blocks.append(block(vector(-11, 14), f, 3, 2))

    blocks.append(block(vector(-9, 10), f, 3, 2))
    blocks.append(block(vector(-9, 11), f, 3, 2))
    blocks.append(block(vector(-9, 12), f, 3, 2))
    blocks.append(block(vector(-9, 13), f, 3, 2))
    blocks.append(block(vector(-9, 14), f, 3, 2))

    blocks.append(block(vector(-6, 10), f, 3, 2))

    blocks.append(block(vector(-3, 10), f, 3, 2))
    blocks.append(block(vector(-3, 11), f, 3, 2))
    blocks.append(block(vector(-3, 12), f, 3, 2))
    blocks.append(block(vector(-3, 13), f, 3, 2))
    blocks.append(block(vector(-3, 14), f, 3, 2))

    blocks.append(block(vector(0, 12), f, 3, 2))
    blocks.append(block(vector(0, 13), f, 3, 2))
    blocks.append(block(vector(0, 14), f, 3, 2))

    blocks.append(block(vector(2, 12), f, 3, 2))
    blocks.append(block(vector(2, 13), f, 3, 2))

    blocks.append(block(vector(4, 10), f, 3, 2))
    blocks.append(block(vector(4, 11), f, 3, 2))
    blocks.append(block(vector(4, 12), f, 3, 2))
    blocks.append(block(vector(4, 13), f, 3, 2))
    blocks.append(block(vector(4, 14), f, 3, 2))

    #159
    blocks.append(block(vector(0, 4), f, 3, 2))
    blocks.append(block(vector(0, 5), f, 3, 2))
    blocks.append(block(vector(0, 6), f, 3, 2))
    blocks.append(block(vector(0, 7), f, 3, 2))
    blocks.append(block(vector(0, 8), f, 3, 2))

    blocks.append(block(vector(3, 4), f, 3, 2))
    blocks.append(block(vector(3, 6), f, 3, 2))
    blocks.append(block(vector(3, 7), f, 3, 2))
    blocks.append(block(vector(3, 8), f, 3, 2))

    blocks.append(block(vector(5, 4), f, 3, 2))
    blocks.append(block(vector(5, 6), f, 3, 2))
    blocks.append(block(vector(5, 5), f, 3, 2))
    blocks.append(block(vector(5, 8), f, 3, 2))

    blocks.append(block(vector(12, 4), f, 3, 2))
    blocks.append(block(vector(12, 5), f, 3, 2))
    blocks.append(block(vector(12, 6), f, 3, 2))
    blocks.append(block(vector(12, 7), f, 3, 2))
    blocks.append(block(vector(12, 8), f, 3, 2))

    blocks.append(block(vector(8, 8), f, 3, 2))
    blocks.append(block(vector(8, 6), f, 3, 2))
    blocks.append(block(vector(8, 7), f, 3, 2))

    blocks.append(block(vector(10, 8), f, 3, 2))
    blocks.append(block(vector(10, 6), f, 3, 2))

    return f, blocks
